/*******************************************************************************
 * Copyright (c) 2000, 2003 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

package org.eclipse.ui.internal.commands.api;

import org.eclipse.ui.keys.KeySequence;

/**
 * <p>
 * JAVADOC
 * </p>
 * <p>
 * This interface is not intended to be extended or implemented by clients.
 * </p>
 * <p>
 * <em>EXPERIMENTAL</em>
 * </p>
 * 
 * @since 3.0
 */
public interface IKeyBindingDefinition extends Comparable {

	/**
	 * JAVADOC
	 * 
	 * @return
	 */	
	String getCommandId();

	/**
	 * JAVADOC
	 * 
	 * @return
	 */	
	String getContextId();

	/**
	 * JAVADOC
	 * 
	 * @return
	 */	
	String getKeyConfigurationId();

	/**
	 * JAVADOC
	 * 
	 * @return
	 */	
	KeySequence getKeySequence();
	
	/**
	 * JAVADOC
	 * 
	 * @return
	 */	
	String getLocale();
	
	/**
	 * JAVADOC
	 * 
	 * @return
	 */	
	String getPlatform();
	
	/**
	 * JAVADOC
	 * 
	 * @return
	 */	
	String getPluginId();
}
