/*******************************************************************************
 * Copyright (c) 2000, 2003 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

package org.eclipse.ui.internal.contexts;

import java.util.List;

import org.eclipse.ui.internal.contexts.api.IContextDefinition;
import org.eclipse.ui.internal.contexts.api.IMutableContextRegistry;
import org.eclipse.ui.internal.util.Util;

abstract class AbstractMutableContextRegistry extends AbstractContextRegistry implements IMutableContextRegistry {

	protected AbstractMutableContextRegistry() {
	}

	public void setContextDefinitions(List contextDefinitions) {
		contextDefinitions = Util.safeCopy(contextDefinitions, IContextDefinition.class);	
		
		if (!contextDefinitions.equals(this.contextDefinitions)) {
			this.contextDefinitions = contextDefinitions;			
			fireContextRegistryChanged();
		}
	}
}
